/*
 *	app.h
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
//#define TURBO -1 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
//#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* 2-bit ADPCM Decodergꍇ́A
 * EUSE_2BIT_ADPCMV{`ĂB
 * EADPCM_CHANNELSV{ɓK؂ȃ`lw肵ĂB
 */
//#define USE_2BIT_ADPCM /*{{TODO}}*/
#ifdef USE_2BIT_ADPCM
#define ADPCM_CHANNELS	4
/* - pTEh`AW4-bit ADPCM̊g2-bit ADPCMɐ؂ւƂɁA
 *   \[XR[h̕ύXȂčςނ悤Aȉ̃}N`邱Ƃɂ܂B
 *   W4-bit ADPCMƊg2-bit ADPCM𕹗pꍇ́ARgAEgĂB
 *   (`l02-bit ADPCM(d)A`l1-34-bit ADPCM𗘗pꍇ)
 */
#define sound_play	adpcm_play
#define sound_stop	adpcm_stop
#endif /*USE_2BIT_ADPCM*/

/* eNX`Xgꍇ́AUSE_TEXTUREV{`ĂB */
#define USE_TEXTURE /*{{TODO}}*/
#ifdef USE_TEXTURE
#define TEXTURE_(name) TEX_##name,
enum {
#include "texture.h"
	TEXTURE_COUNT,
};
extern TEXTURE texture_table[TEXTURE_COUNT];
#undef TEXTURE_
#endif /*USE_TEXTURE*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
//#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* 3D`gꍇ́A
 * EUSE_3DV{`ĂB
 * EFRONTɓK؂ȑOʃNbsO(_`eʋ)w肵ĂB
 * EBACK ɓK؂ȔwʃNbsO(_`E)w肵ĂB
 * EFOVY ɓK؂Ȑpxw肵ĂB
 */
//#define USE_3D /*{{TODO}}*/
#ifdef USE_3D
#define FRONT	fld(1)
#define BACK	fld(100)
#define FOVY	DEG(45)
#endif /*USE_3D*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB
 * ܂AAvP[V̒ʏwiFɂ킹āAPAUSE_COLORIĂB
 */
//#define USE_PAUSE /*{{TODO}}*/
#ifdef USE_PAUSE
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#ifndef LDIRECT_INTERVAL
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#else /*LDIRECT_INTERVAL*/
#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#endif /*LDIRECT_INTERVAL*/
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */
#endif /*USE_PAUSE*/

/* USBt@CVXeG~[Vgꍇ́AUSE_UFEV{`ĂB */
//#define USE_UFE

/* USBt@CVXeG~[Vƃg[Xo͕͂pł܂B */
#if defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)
#error USBt@CVXeG~[Vƃg[Xo͕͂pł܂B
#endif /*defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)*/

/* TCP/IPvgRXC[ggꍇ́AUSE_TCPIPV{`ĂB */
//#define USE_TCPIP

/* TCP/IPvgRXC[gƃg[Xo͕͂pł܂B */
#if defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)
#error TCP/IPvgRXC[gƃg[Xo͕͂pł܂B
#endif /*defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)*/

#ifdef USE_TCPIP
#include "tcpip.h"
#endif /*USE_TCPIP*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void update();
void schedule();
void delay(int frame);
int demo_main();
void game_main();

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
