/*
 *	app.h
 *
 *	REF-LECT BALL (ڐA)
 *
 *	* Mon Jan 01 23:01:25 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

#define APP_FNAME	"reflectb.pex"

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO -1 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
//#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* 2-bit ADPCM Decodergꍇ́A
 * EUSE_2BIT_ADPCMV{`ĂB
 * EADPCM_CHANNELSV{ɓK؂ȃ`lw肵ĂB
 */
#define USE_2BIT_ADPCM /*{{TODO}}*/
#ifdef USE_2BIT_ADPCM
#define ADPCM_CHANNELS	4
/* - pTEh`AW4-bit ADPCM̊g2-bit ADPCMɐ؂ւƂɁA
 *   \[XR[h̕ύXȂčςނ悤Aȉ̃}N`邱Ƃɂ܂B
 *   W4-bit ADPCMƊg2-bit ADPCM𕹗pꍇ́ARgAEgĂB
 *   (`l02-bit ADPCM(d)A`l1-34-bit ADPCM𗘗pꍇ)
 */
#define sound_play	adpcm_play
#define sound_stop	adpcm_stop
#endif /*USE_2BIT_ADPCM*/

/* eNX`Xgꍇ́AUSE_TEXTUREV{`ĂB */
#define USE_TEXTURE /*{{TODO}}*/
#ifdef USE_TEXTURE
#define TEXTURE_(name) TEX_##name,
enum {
#include "texture.h"
	TEXTURE_COUNT,
};
extern TEXTURE texture_table[TEXTURE_COUNT];
#undef TEXTURE_
#endif /*USE_TEXTURE*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* 3D`gꍇ́A
 * EUSE_3DV{`ĂB
 * EFRONTɓK؂ȑOʃNbsO(_`eʋ)w肵ĂB
 * EBACK ɓK؂ȔwʃNbsO(_`E)w肵ĂB
 * EFOVY ɓK؂Ȑpxw肵ĂB
 */
//#define USE_3D /*{{TODO}}*/
#ifdef USE_3D
#define FRONT	fld(1)
#define BACK	fld(100)
#define FOVY	DEG(45)
#endif /*USE_3D*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB
 * ܂AAvP[V̒ʏwiFɂ킹āAPAUSE_COLORIĂB
 */
#define USE_PAUSE /*{{TODO}}*/
#ifdef USE_PAUSE
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#ifndef LDIRECT_INTERVAL
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#else /*LDIRECT_INTERVAL*/
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#endif /*LDIRECT_INTERVAL*/
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */
#endif /*USE_PAUSE*/

/* USBt@CVXeG~[Vgꍇ́AUSE_UFEV{`ĂB */
//#define USE_UFE

/* USBt@CVXeG~[Vƃg[Xo͕͂pł܂B */
#if defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)
#error USBt@CVXeG~[Vƃg[Xo͕͂pł܂B
#endif /*defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)*/

/* TCP/IPvgRXC[ggꍇ́AUSE_TCPIPV{`ĂB */
//#define USE_TCPIP

/* TCP/IPvgRXC[gƃg[Xo͕͂pł܂B */
#if defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)
#error TCP/IPvgRXC[gƃg[Xo͕͂pł܂B
#endif /*defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)*/

#ifdef USE_TCPIP
#include "tcpip.h"
#endif /*USE_TCPIP*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	ONE_SEC			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void update();
void schedule();
void delay(int frame);
void app_main();

/****************************************************************************
 *	
 ****************************************************************************/

#define ONE_SEC		60
#define ONE_MIN		(ONE_SEC * 60)

#define SCREEN_SX	640
#define SCREEN_SY	480
#define SCREEN_MX	(SCREEN_SX / 2)
#define SCREEN_MY	(SCREEN_SY / 2)

#define SHIP_AREAMAX_X	(SCREEN_MX)
#define SHIP_AREAMAX_Y	(SCREEN_MY)

#define ENEMY_AREAMAX_X	(SCREEN_MX + 16.0f)
#define ENEMY_AREAMAX_Y	(SCREEN_MY + 16.0f)

#define X		0
#define Y		1
#define XY		2

/*--------------------------------------------------------------------------*/
/* boot.c */

void boot();
int Rand();

/*--------------------------------------------------------------------------*/
/* snd.c */

enum {
	SND_BGM00,
	SND_BGM01,
	SND_BGM02,
	//
	SND_SESELECT,
	SND_SECOLLECT,
	SND_SECANCEL,
	SND_SESTART,
	SND_SESSHOT,
	SND_SESBRK,
	SND_SEEDMG,
	SND_SEEBRK1,
	SND_SEEBRK2,
	SND_SEEBRK3,
	//
	SND_COUNT,
};

void sndINIT();
void playSND(int no);
void stopSND(int no);

/*--------------------------------------------------------------------------*/
/* task.c */

enum {
	GROUP_00,
	GROUP_01,
	GROUP_02,
	GROUP_03,
	GROUP_04,
	GROUP_05,
	GROUP_06,
	GROUP_07,
	GROUP_08,
	GROUP_MAX,
	//
	GROUP_SYSTEM	= GROUP_00,
	GROUP_BG	= GROUP_01,
	GROUP_EFFECT	= GROUP_02,
	GROUP_SSHOT	= GROUP_03,
	GROUP_ENEMY	= GROUP_04,
	GROUP_ESHOT	= GROUP_05,
	GROUP_SHIP	= GROUP_06,
	GROUP_INFO	= GROUP_07,
	GROUP_TOPFRAME	= GROUP_08,
};

typedef struct tagTSK TSK;
struct tagTSK {
	LIST_ENTRY	list_entry;
	/* system */
	void		(*fp)(TSK* tsk);
	void		(*fp_int)(TSK* tsk, TSK* etsk);
	void		(*fp_draw)(TSK* tsk);
	int		step;
	int		wait;
	int		cnt;
	float		px;
	float		py;
	float		vx;
	float		vy;
	float		tx;
	float		ty;
	float		cx;
	float		cy;
	float		rot;
	float		rot_add;
	/* game */
	int		score;
	/* draw */
	int		body_len;
	float		body_ang[4/**/][2];
	/* BulletML */
	BulletMLBullet*	bullet;
	float		bullet_dir;
	float		bullet_spd;
	float		bullet_accx;
	float		bullet_accy;
	float		rank;
};

/*{{ߖ̂߁AtB[h*/
#define	ang		rot
#define energy		body_len
#define ax		body_ang[0][0]
#define ay		body_ang[0][1]
#define alpha		body_ang[1][0]
#define alpha_add	body_ang[1][1]
#define cen_x		body_ang[2][0]
#define cen_y		body_ang[2][1]
#define rad_x		body_ang[3][0]
#define rad_y		body_ang[3][1]
/*}}ߖ̂߁AtB[h*/

void initTSK();
TSK* setTSK(int group, void (*fp)(TSK* tsk));
void clrTSK(TSK* tsk);
void clrTSKgroup(int group);
void execTSK();
void drawTSK();

/*--------------------------------------------------------------------------*/
/* bullet.c */

enum {
	BULLET_ENEMY01,
	BULLET_ENEMY02,
	//
	BULLET_COUNT,
};

void bulletINIT();
void bulletSet(TSK* tsk, int no);
void bulletDel(TSK* tsk);
int bulletRun(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* gctrl.c */

enum {
	GSTEP_TITLE,
	GSTEP_GAME,
	GSTEP_RESULT,
	GSTEP_RANKING,
};

enum {
	GCTRL_INIT,
	GCTRL_TITLE,
	GCTRL_WAIT,
	GCTRL_START,
	GCTRL_GAME1,
	GCTRL_GAME2,
	GCTRL_GAME3,
	GCTRL_GAME4,
	GCTRL_GAMEEND,
	GCTRL_RANKING,
	GCTRL_RANKING_EXEC,
	GCTRL_RANKING_EXIT,
};

void TSKgctrl(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* bg.c */

void TSKbgStar(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* title.c */

void TSKtitle(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* ranking.c */

//#define RANKING_MAX	20
//P/ECE͉ʂ20ʂ\łȂ̂ŁA炵܂B
#define RANKING_MAX	10

enum {
	RANKING_SCORE,
	RANKING_BREAK,
	RANKING_DESTR,
	RANKING_RECORD,
};

void TSKranking(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* sysinfo.c */

void TSKsysinfo(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* ship.c */

void TSKship(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* enemy.c */

#define ENEMY_DIV1	4	/* XCX */
#define ENEMY_DIV2	6	/* ~ */

void INITenemy();
void TSKenemyInt(TSK* tsk, TSK* etsk);
void TSKenemyDraw(TSK* tsk);

void TSKeshot(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* enemy01.c */

void TSKenemy01(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* enemy02.c */

void TSKenemy02(TSK* tsk);

/*--------------------------------------------------------------------------*/
/* effect.c */

void effSetParticle(TSK* tsk, int cnt);
void effSetBrokenBody(TSK* tsk, const float poly[/*cnt*/][2], int cnt, float scale);
void effSetBrokenLine(TSK* tsk, const float poly[/*cnt*/][2], int cnt, float scale);

/*--------------------------------------------------------------------------*/

int getPointX(fixed p);
int getPointY(fixed p);
int getColor(fixed r, fixed g, fixed b, fixed a);
/*{{ŏ*/
int _getPointX(float p);
int _getPointY(float p);
int _getColor(float r, float g, float b, float a);
/*}}ŏ*/
void drawNoise(int y, int h);
void setForm(TSK* tsk, const float poly[/*len*/][2], int len, float scale);
void getVertex(TSK* tsk, int i, int* x, int* y);
void drawLineLoop(TSK* tsk, int start, int cnt, int c);
void drawLines(TSK* tsk, int start, int cnt, int c);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
