#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void TSKenemyAnim(TSK* tsk);

#define SCORE	3
#define ENERGY	3

void
TSKenemy01(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->fp_draw = TSKenemyDraw;
		tsk->px = (rand() % (SCREEN_SX - 64)) - (SCREEN_MX - 32);	/* -(SCREEN_MX-32) ` +(SCREEN_MX-32) */
		tsk->py = -SCREEN_MY - 16.0f;
		tsk->tx = -tsk->px;
		tsk->ty = -SCREEN_MY + 80.0f;
		tsk->vx = (tsk->px < tsk->tx) ? +0.5f : -0.5f;
		tsk->vy = 1.0f;
		tsk->ax = 0.225f;
		tsk->ay = 0.225f;
		tsk->cx = 16.0f;
		tsk->cy = 8.0f;
		tsk->energy = ENERGY;
		tsk->score = SCORE;
		tsk->step++;
		break;

	case 1:
		tsk->fp_int = TSKenemyInt;
		TSKenemyAnim(tsk);
		bulletRun(tsk);
		break;

	case 100:
		if(!bulletRun(tsk)) {
			tsk->step = -1;
		}
		break;

	default:
		enemy_now--;
		enemy_dst++;
		if(!(enemy_dst % 20)) enemy_max++;
		clrTSK(tsk);
		break;
	}
}

static void
TSKenemyAnim(TSK* tsk)
{
	tsk->cnt = (tsk->cnt + 1) & 63;
	tsk->px += tsk->vx;
	tsk->py += tsk->vy;
	tsk->vx += tsk->px < tsk->tx ? +tsk->ax : -tsk->ax;
	tsk->vy += tsk->py < tsk->ty ? +tsk->ay : -tsk->ay;
}

